
validate(){
	if [ $ITER -eq ' ' ]; then
		ITER=20
	fi
	if [ $INC -eq ' ' ]; then
		INC=50
	fi
	if [ $SAMPLES -eq ' ' ]; then
		SAMPLES=200
	fi
	if [ $VS -eq ' ' ]; then
		VS=4
	fi
}

create_strings()
{
 echo "Creating the strings"
 echo ""
 COUNT=1
 while [ $COUNT -le 5 ]; do
	C=1
        while [ $C -le $ITER ]; do
	     DBS=$[$SAMPLES+$INC*$C]
	     ./m-strings -i ../tmp/prob_$COUNT.txt -o ../tmp/string_$COUNT-$DBS.txt -dbs $DBS
             let C=C+1
        done
	let COUNT=COUNT+1
 done
}

create_transducer()
{
 echo "Creating the random transducer"
 echo ""
 ./m-rtrans -o ../tmp/transducer.txt -vs $VS
}

create_db()
{
 echo "Creating the databases"
 echo ""
 COUNT=1
 while [ $COUNT -le 5 ]; do
	C=1
        while [ $C -le $ITER ]; do
	     DBS=$[$SAMPLES+$INC*$C]
        	./m-snn -i ../tmp/string_$COUNT-$DBS.txt -t ../tmp/transducer.txt -o ../tmp/db_$COUNT-$DBS.txt
                let C=C+1
        done
	let COUNT=COUNT+1
 done
}

create_conditional()
{
 echo "Creating the Conditional Transducer"
 echo ""
 COUNT=1
 while [ $COUNT -le 5 ]; do
	C=1
        while [ $C -le $ITER ]; do
		DBS=$[$SAMPLES+$INC*$C]
        	./lsed -i ../tmp/db_$COUNT-$DBS.txt -o ../tmp/c_trans_$COUNT-$DBS.txt -na c
        	let C=C+1
        done
	let COUNT=COUNT+1
 done
}

create_joint()
{
 echo "Creating the Joint Transducer"
 echo ""
 COUNT=1
 while [ $COUNT -le 5 ]; do
	C=1
        while [ $C -le $ITER ]; do
		DBS=$[$SAMPLES+$INC*$C]
                ./lsed -i ../tmp/db_$COUNT-$DBS.txt -o ../tmp/j_trans_$COUNT-$DBS.txt -na j
                let C=C+1
        done
	let COUNT=COUNT+1
 done
}

distance()
{
 echo "Evaluating the Distance"
 echo ""
 COUNT=1
 while [ $COUNT -le 5 ]; do
	C=1
        while [ $C -le $ITER ]; do
		DBS=$[$SAMPLES+$INC*$C]
		./trans-dist -if ../tmp/transducer.txt -is ../tmp/c_trans_$COUNT-$DBS.txt -dbs $DBS \
			-d c >> ../tmp/c_distances_$COUNT.txt
		./trans-dist -if ../tmp/transducer.txt -is ../tmp/j_trans_$COUNT-$DBS.txt -dbs $DBS \
			-d j >> ../tmp/j_distances_$COUNT.txt
	 	let C=C+1
	 done
	 let COUNT=COUNT+1
 done
}

        OPTION="$1"
        VS="$2"
	ITER="$3"
	INC="$5"
	SAMPLES="$5"
	case $OPTION in
		-s)	create_strings
			create_transducer
			create_db
			create_conditional
			create_joint
			distance
		;;
		-d)	distance
		;;
		*) echo "Usage: ./synthetic.sh -[s|d] [vocabulary size]"
		   echo " [numOfIterations] [Increment] [InitialSamples]"
		exit 1
		;;
	esac
