#ifndef distance_h
#define distance_h

#include <iostream>
#include <fstream>
#include "../src/pair_database.h"
#include "../src/transducer.h"
#include "../src/edit_distance.h"

Pair_database input_database(string file_db, int verbosity) {
	Pair_database db;
	if( !file_db.empty() ) {
		ifstream ds(file_db.c_str());
		if( !ds ) {
			cout << "ERROR: I can't open '" 
                             << file_db.c_str() << "'" << endl;
			exit(-1);
		}
		ds >> db;
	}
	if( verbosity > 2 )  {
		cout << "Learning Strings base:" << endl;
		cout << db;
	}
	return db;
}

void print_database(string file, Pair_database db)
{
	if( !file.empty() ) {
		ofstream fs;
		fs.open(file.c_str());
		fs << db;
		fs.close();
	}
}

Edit_distance input_edit_distance(string file_ed, int verbosity) {
	Edit_distance ed;
	if( !file_ed.empty() ) {
		ifstream dt(file_ed.c_str());
		if( !dt ) {
			cout << "ERROR: I can't open '" 
	                     << file_ed.c_str() << "'" << endl;
			exit(-1);
		}
		dt >> ed;
	}
	if( verbosity > 2 ) {
		cout << "Result:" << endl;
		cout << ed << endl;
	}
	return ed;
}

#endif

