#ifndef automaton_h
#define automaton_h

#include <iostream>
#include <fstream>
#include <vector>
#include <map>


using namespace std;

class Automata {
	vector<char> sym;
	map<char,double> probabilities;

	public:

	Automata(){
		sym.clear();
		probabilities.clear();
	}

	int size() {
		return sym.size();
	}

	void set_prob(char c, double prob ) {
		sym.push_back(c);
		probabilities[c] = prob;
	}

	char get_symbol( unsigned c ) const{
		if( c >= sym.size() ) {
			cerr << "ERROR in symbol: unknown probability" << endl;
			abort();
		}
		return sym[c];
	}

	double get_prob( char s ) {
		if( probabilities.count(s) == 0 ) {
			cerr << "ERROR in symbol: unknown probability" << endl;
			abort();
		}
		return probabilities[s];
	}
};


istream& operator>>(istream &is, Automata &a);
void write_strings(Automata a, int db_size, string file_string);

#endif
