#ifndef algorithm_h
#define algorithm_h

#include <iostream>
#include <fstream>
#include <vector>
#include "mystring.h"
#include "transducer.h"
#include "trellis.h"

using namespace std;

class Algorithm {

	int size;		//Number of algorithm
	int ls_size;		//LS Size
	int ts_size;		//TS size
	vector<string> alg;	//Name of algorithm
	vector<int> tp;		//Number of True Positive

public:

	Algorithm(){};

	void initialize(int alg_size){
		alg.resize(alg_size);
		tp.resize(alg_size);
		size = alg_size;
		ls_size=0;
		ts_size=0;
	};

	void initialize(int alg_size, int ls, int ts){
		alg.resize(alg_size);
		tp.resize(alg_size);
		size = alg_size;
		ls_size=ls;
		ts_size=ts;
	};

	void set_name(int i, string name){
		tp[i] = 0;
		alg[i] = name;
	};

	void set_tp(int i, int t_p){
		tp[i] = t_p;
	};
	
	string get_name(int i){
		return alg[i];
	}

	int get_tp(int i){
		return tp[i];
	};

	int get_size(){
		return size;
	};

	int get_ts_size(){
		return ts_size;
	};

	int get_ls_size(){
		return ls_size;
	};

	void print_result(Algorithm alg);

	double prob(Transducer t, MyString x, MyString y);
};

ostream& operator<<( ostream& os, Algorithm &alg);

#endif

