#ifndef edit_distance_h
#define edit_distance_h

#include <vector>
#include "matrix.h"
#include "mystring.h"
#include "transducer.h"
#include <iostream>
class Edit_distance {

	Matrix f_sw;
	vector<double> f_iw;
	vector<double> f_dw;

public:

	Edit_distance() {};

	void initialize( int voc_size );

	int size(){
		return f_sw.size();
	}

	double& ins( int i ){
		return f_iw[i];
	};

	double& del( int i ){
		return f_dw[i];
	};

	double& sub( int i, int j ){
		return f_sw(i, j);
	};

	double operator()( const MyString &s1, const MyString &s2 ) const;

};

ostream& operator<<( ostream& os, Edit_distance &ed);
istream& operator>>( istream& is, Edit_distance &ed);

#endif


