#ifndef EM_H
#define EM_H

#include "mystring.h"
#include "transducer.h"
#include "pair_database.h"
#include "trellis.h"

using namespace std;

class EM {
	int f_verbosity;
	double f_precision;
	int iter;
	double prob;

public:

	EM() : f_verbosity(0), f_precision(1E-5) {}

        int iterations() {
		return iter;
	}

	double probability() {
		return prob;
	}

	int& verbosity() {
		return f_verbosity;
	}

	int verbosity() const {
		return f_verbosity;
	}

	double& precision() {
		return f_precision;
	}

	double precision() const {
		return f_precision;
	}


        Transducer operator()( 
			Pair_database &db,
			void  (*normalize)(Transducer&) 
					= normalize_maximum_likelihood );
};


double log_prob(const Transducer    &t, 
		const Pair_database &db );

#endif
