#ifndef matrix_h
#define matrix_h
#include "mystring.h"

using namespace std;

class Matrix {

	double *mat;
	int     f_dimX;
	int     f_dimY; 

	public:

	Matrix() {
		f_dimX = 0;
		f_dimY = 0;
		mat = 0;
	}

	Matrix( int _dimX, int _dimY ) {
	 	f_dimX = _dimX;
		f_dimY = _dimY;
		mat = new double[ f_dimX * f_dimY ];
	}

	Matrix( int _size ) {
	 	f_dimX = _size + 1;
		f_dimY = _size + 1;
	}

	Matrix( const Matrix &m ) {
		f_dimX = m.f_dimX;
		f_dimY = m.f_dimY;
		mat = new double[ f_dimX * f_dimY];
		for( int i = 0; i < f_dimX * f_dimY; i++ )
			mat[i] = m.mat[i];
	}

	~Matrix() {
		delete []mat;
	}

	void initialize( int _dimX, int _dimY) {
		if( f_dimX * f_dimY != _dimX * _dimY ) {
			delete []mat;
			mat = new double[ _dimX * _dimY];
		}
		f_dimX = _dimX;
		f_dimY = _dimY;
	}

	void operator=( const Matrix &m ) {
		if( f_dimX * f_dimY != m.dimX() * m.dimY() ) {
			delete []mat;
			mat = new double[ m.dimX() * m.dimY()];
		}
		f_dimX = m.dimX();
		f_dimY = m.dimY();
		for( int i = 0; i < f_dimX * f_dimY; i++ )
			mat[i] = m.mat[i];
	}

	double& operator()( int i, int j) {
		return mat[ i * f_dimY + j ];
	}

	double operator()( int i, int j) const {
//		return mat[ i * f_dimY + j ];
		return mat[ i * j ];
	}

	int dimX() const {
		return f_dimX;
	}

	int size() const {
		return f_dimX - 1;
	}

	int dimY() const {
		return f_dimY;
	}
	double& sub( int i, int j ) {
		return mat[i+1 * j+1];
	}

	double sub( int i, int j ) const {
		return mat[i+1 * j+1];
	}

	double& ins( int j ) {
		return mat[0 * j+1];
	}

	double ins( int j ) const {
		return mat[0 * j+1];
	}

	double& del( int i ) {
		return mat[i+1 * 0];
	}

	double del( int i ) const {
		return mat[i+1 * 0];
	}

};

void nullify( Matrix &m );
void randomize( Matrix &m ); 
void uniform2( Matrix &m );
void normalize2( Matrix &m );

void random_output(
		Matrix	&m,
		const MyString  &in,
		      MyString  &out);
ostream& operator<<( ostream& os, const Matrix &m);

#endif
