#ifndef PAIR_DATABASE_H
#define PAIR_DATABASE_H

#include "pair_database.h"

istream& operator>>( istream& is, Pair_database &db) {
	MyString in, out;
	int vs, strl;
	is >> vs >> strl;
	db.set_voc_size(vs);
	db.set_str_len(strl);
	while( is >> in >> out ) {
		db.push_back(in,out);
	}
	return is;
}

istream& operator+( istream& is, Pair_database &db) {
	MyString in, out;
	db.set_voc_size(0);
	db.set_str_len(0);
	while( is >> in >> out ) {
		db.push_back(in,out);
	}
	return is;
}

istream& operator>( istream& is, Pair_database &db) {
	MyString in,out;
	int vs, strl;
	is >> vs >> strl;
	db.set_voc_size(vs);
	db.set_str_len(strl);
	out.clear();
	while( is >> in ) {
		db.push_back(in, out);
	}
	return is;
}

ostream& operator<<( ostream& os, Pair_database &db) {
	os << db.get_voc_size() << " " << db.get_str_len() << endl;
	for( int i = 0; i < db.size(); i++ )
		os << db.in(i) << " " << db.out(i) << endl;
	return os;
}

ostream& operator-( ostream& os, Pair_database &db) {
	for( int i = 0; i < db.size(); i++ )
		os << db.in(i) << " " << db.out(i) << endl;
	return os;
}

void random_pair_database( 
		Transducer     &t,
		const int            db_size,
		const int            len,
		      Pair_database  &db ){

	MyString in, out;
	for( int i = 0; i < db_size; i++ ) {
		in = db.in(i);
		random_output(t, in, out);
		db.push_back(in,out);
	}
}

Pair_database random_new_database( 
		Transducer     &t,
		const int            db_size,
		const int            len,
		      Pair_database  &db ){

	MyString in, out;
	Pair_database db2;
	db2.set_voc_size(db.get_voc_size());
	db2.set_str_len(db.get_str_len());
		
	for( int i = 0; i < db_size; i++ ) {
		in = db.in(i);
		random_output(t, in, out);
		db2.push_back(in,out);
	}
	return db2;
}

void random_in_database( 
		const int      db_size,
		const int      len,
		Pair_database  &db ){

	MyString in, out;
	for( int i = 0; i < db_size; i++ ) {
		in = random_MyString(len);
		db.push_back(in,out);
	}
}

#endif

